/* DefGlSet.cpp -- Default Global Settings */

#include "DefGlSet.h"

#include "GlSttngs.h"

#define gS globalSettings
#define BS BooleanSetting
#define IS IntegerSetting
#define RS RealSetting
#define SS StringSetting

/*         */
void setDefaultGlobalSettings()
  {

    /*    */
    gS.add( BS( "InjectOnly",                    false          ) );
    gS.add( IS( "NumberOfRandomSpeciesTrees",    0              ) );
    gS.add( IS( "NumberOfResultSpeciesTrees",    0              ) );
    gS.add( BS( "ResumeCalculations",            false          ) );
    gS.add( IS( "AutosavePeriod",                100            ) );
    gS.add( BS( "LookForBadGenes",               false          ) );
    gS.add( BS( "AnalyseEvolutionaryEvents",     false          ) );

    /*    */
    gS.add( RS( "CostRatio",                     1.0            ) );
    gS.add( IS( "LocalOptimizationsOrder",       0              ) );
    gS.add( BS( "UseEmpiricalProbability",       true           ) );
    gS.add( IS( "RandomNumberSeed",              0              ) );

    /*  /  */
    gS.add( SS( "GenesTableFileName",            "GTable"       ) );
    gS.add( SS( "GeneTreesFileName",             "GTrees.gt"    ) );
    gS.add( SS( "SpeciesTreeFileName",           "STree.st"     ) );
    gS.add( SS( "ResultFileName",                "Result.ph"    ) );
    gS.add( SS( "BadGenesFileName",              "BadGenes.txt" ) );
    gS.add( SS( "LogFileName",                   "TIQMax.log"   ) );
    gS.add( SS( "SettingsFileName",              "TIQMax.set"   ) );

    /* , -    */
    gS.add( BS( "CheckGeneTrees",                true           ) );
    gS.add( SS( "GenesToExclude",                ""             ) );
    gS.add( BS( "MergeOneSpeciesSubtrees",       false          ) );
    gS.add( BS( "IgnoreLengths",                 false          ) );
    gS.add( BS( "OrderSpeciesTreesBranches",     true           ) );
    gS.add( BS( "DefineLengthsOnSpeciesTree",    false          ) );
    gS.add( RS( "GeneTreeNormFactor",            0              ) );
    gS.add( BS( "ProduceGeneTreesFiles",         false          ) );

    /*      */
    gS.add( RS( "CostRatio2",                    0.1            ) );
    gS.add( RS( "CostDeltaThreshold",           -7              ) );
    gS.add( RS( "DispersionThreshold",           2              ) );
    gS.add( RS( "CostDeltaPValueThreshold",      0.1            ) );
    gS.add( RS( "DispersionPValueThreshold",     0.1            ) );
    gS.add( IS( "NeighbourhoodRadius",           5              ) );
    gS.add( BS( "SimpleInjectionAnalysisOutput", false          ) );

    /*   */
    gS.add( BS( "ShowProgressBar",               true           ) );
    gS.add( BS( "BeepOnNewMinimum",              false          ) );

    /*    */
    gS.add( BS( "ShowPhylipTrees",               true           ) );
    gS.add( BS( "ShowPseudographicsTrees",       true           ) );
    gS.add( BS( "ShowTreeInfo",                  true           ) );
    gS.add( BS( "ShowInjections",                true           ) );
    gS.add( BS( "ShowInjectionsInfo",            true           ) );
    gS.add( BS( "ShowInjectionStatistics",       true           ) );
    gS.add( BS( "ShowInjectionTables",           true           ) );
    gS.add( BS( "ShowInjectionTrees",            true           ) );
    gS.add( BS( "SortInjections",                false          ) );
    gS.add( BS( "NormalizeGeneTrees",            false          ) );

    /*     */
    gS.add( BS( "LogAllowed",                    false          ) );
    gS.add( BS( "LogOutAbsentGenes",             true           ) );
    gS.add( BS( "LogOutCutGeneTrees",            true           ) );
    gS.add( BS( "LogOutInitialInjections",       false          ) );
    gS.add( BS( "LogOutInitialTrees",            true           ) );
    gS.add( BS( "LogOutOptimizedInjections",     false          ) );
    gS.add( BS( "LogOutPreparedTrees",           false          ) );
    gS.add( BS( "LogOutProgramSettings",         true           ) );
    gS.add( BS( "LogOutProximityMatrix",         false          ) );
    gS.add( BS( "LogOutRandomSpeciesTrees",      true           ) );
    gS.add( BS( "WarnAmbiguousTransitions",      false          ) );

  }
