/* TreeBase.h */

#ifndef __TREEBASE_H
#define __TREEBASE_H

#include "Sortable.h"

_CLASSDEF(TreeBase)

/*       */
abstract class TreeBase : public Sortable
  {

  protected :

    /* / */
    TreeBase( uint aDelta=2 ) :
      _nOfChildren(0), _parent(NULL), _children(NULL), _delta(aDelta) {}
    virtual ~TreeBase();

    /*    */

    void flush();  //  ,   

    /*    -      */
    uint numberOfChildren () const { return  _nOfChildren;    }
    bool hasParent        () const { return (_parent!=NULL);  }
    bool hasChild         () const { return (_nOfChildren>0); }

    /*    / */
    RCTreeBase parent   ()         const { return *_parent;      }
    RTreeBase  parent   ()               { return *_parent;      }
    RCTreeBase child    ( uint n ) const { return *_children[n]; }
    RTreeBase  child    ( uint n )       { return *_children[n]; }
    RPTreeBase childPtr ( uint n )       { return  _children[n]; }
    int removeChild( int number );
    int childNumber( RCTreeBase childToFind ) const;

    /*  /    */
    void meetParent( RTreeBase newParent ) { _parent=&newParent; }
    void forgetParent()                    { _parent=NULL;       }

    /*        */
    int addChildPtr( PTreeBase newChildPtr );
    int removeChildPtr( int number );

  private :

    /*         */
    int atAdd();     //    (     )
    int atRemove();  //     (  )

    /* -  */
    uint       _nOfChildren;  //  () 
    PTreeBase  _parent;       //   
    PPTreeBase _children;     //     

  protected:

    const uint _delta;  //     

  };

inline int TreeBase::addChildPtr( PTreeBase newChildPtr )
  {
    const int newChildNumber=atAdd();

    _children[newChildNumber] = newChildPtr;
    _children[newChildNumber]->meetParent(ME);

    return newChildNumber;
  }

#endif  // __TREEBASE_H

