/* TreeOut.h */

#ifndef __TREEOUT_H
#define __TREEOUT_H

#include "Tree.h"
#include "DupTree.h"
#include "TInject.h"
#include "TreeMan.h"

_CLASSDEF(TreePrinter)

class TreePrinter
  {

  public :

    TreePrinter() {}
    ~TreePrinter() {}

    void psGraphPrint ( RCTree          aTree,    ostream& os=cout ) const;
    void phylipPrint  ( RCBioTree       aBioTree, ostream& os=cout ) const;
    void phylipPrint  ( RCTreeInjection tInject,  ostream& os=cout ) const;
    void columnPrint  ( RCTreeInjection tInject,  ostream& os=cout ) const;

    void printGeneTrees   ( RCClArray        gTrees, ostream& os=cout ) const;
    void printGeneTree    ( GeneTree         gTree,  ostream& os=cout ) const;
    void printSpeciesTree ( SpeciesTree      sTree,  ostream& os=cout ) const;
    void printInjections  ( ClArray          gTrees,
                            DuplicationsTree dTree,  ostream& os=cout ) const;

  protected:

    void printTree_Exp( RBioTree tree, ostream& os=cout ) const;

  };

inline void TreePrinter::printGeneTree    ( GeneTree    gT, ostream& os ) const
  { printTree_Exp( gT, os ); }
inline void TreePrinter::printSpeciesTree ( SpeciesTree sT, ostream& os ) const
  { printTree_Exp( sT, os ); }

#endif  // __TREEOUT_H

